declare enum QueryType {
    columns = "C",
    describe = "D"
}
interface QueryConfig {
    columns: (tableName: string) => string;
    describe: (tableName: string) => string;
}
interface DriverConfig {
    jar: string;
    connectionType: string;
    className: string;
    version: string;
    query: QueryConfig;
}
interface DatabaseConfig {
    driverPath: string;
    hive: DriverConfig;
    postgresql: DriverConfig;
    sqlite: DriverConfig;
    tibero: DriverConfig;
    firebirdsql: DriverConfig;
    getJar: (type: keyof DatabaseConfig) => string;
    getDriver: (type: keyof DatabaseConfig) => DriverConfig;
}
interface DriverType {
    driver: DriverConfig;
    get_config: () => object;
    get_query: (tableName: string, type: string) => string;
}
declare const db: DatabaseConfig;
export { db, DriverType, DriverConfig, QueryType };
